package geniusweb.protocol.session.amop;

import static org.junit.Assert.assertEquals;

import org.junit.Test;

public class WillBeCalledTest {
	int counter;

	@Test
	public void testDeadline() throws InterruptedException {
		counter = 0;
		new WillBeCalled(() -> {
			counter++;
		}, 100l);
		assertEquals(0, counter);
		Thread.sleep(200);
		assertEquals(1, counter);
		Thread.sleep(200);
		assertEquals(1, counter);

	}

	@Test
	public void testManual() throws InterruptedException {
		counter = 0;
		WillBeCalled w = new WillBeCalled(() -> {
			counter++;
		}, 100l);
		assertEquals(0, counter);
		w.complete();
		assertEquals(1, counter);
		Thread.sleep(200);
		assertEquals(1, counter);

	}
}
